/*-
 * Copyright (c) 2000
 * Tatsuya Kudoh(CDR/TK),ROYALPANDA.    All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include<sys/bios.h>
#include"jump.h"


void KEY_init( void )
{
}

int KEY_read( int mode )
{
	int k,c;

	switch( mode ){
	case 0:
		c = key_press_check();
		break;

	case 1:
		c = key_hit_check();
		break;

	case 2:
		c = key_hit_check_with_repeat();
		break;
	}

	k = 0;

	if( c & 1<<1 )
		k |= K_START;

	switch( c & 5<<5 ){
	case 1<<5:
		k |= K_RIGHT;
		break;
	case 4<<5:
		k |= K_LEFT;
		break;
	}

	switch( c & 5<<4 ){
	case 1<<4:
		k |= K_UP;
		break;
	case 4<<4:
		k |= K_DOWN;
		break;
	}

	if( c & 1<<2 )
		k |= K_A;

	if( c & 1<<3 )
		k |= K_B;

	if( c & 1<<8 )
		k |= K_RESET;

	return k;
}


void KEY_wait_pause( void )
{
	while( !(key_wait() & 1<<1) )
		;
	while( key_press_check() & 1<<1 )
		;
}
